<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="用户ID" prop="userId">
        <el-input
          v-model="queryParams.id"
          placeholder="请输入用户ID"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="昵称" prop="nickname">
        <el-input
          v-model="queryParams.nickname"
          placeholder="请输入昵称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select
          v-model="queryParams.status"
          placeholder="请选择状态"
          clearable
          class="!w-240px"
        >
          <el-option label="非正常" :value="0" />
          <el-option label="正常" :value="1" />
        </el-select>
      </el-form-item>
      <el-form-item label="姓名" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入姓名"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input
          v-model="queryParams.mobile"
          placeholder="请输入手机号"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="是否VIP" prop="isVip">
        <el-select
          v-model="queryParams.isVip"
          placeholder="请输入是否VIP"
          clearable
          class="!w-240px"
        >
          <el-option label="否" :value="0" />
          <el-option label="是" :value="1" />
        </el-select>
      </el-form-item>
      <el-form-item label="是否拉黑" prop="isBanned">
        <el-select
          v-model="queryParams.isBanned"
          placeholder="请输入是否拉黑"
          clearable
          class="!w-240px"
        >
          <el-option label="否" :value="0" />
          <el-option label="是" :value="1" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['yuesao:YS-user:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['yuesao:YS-user:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="用户ID" align="center" prop="id" fixed="left" />
      <el-table-column label="昵称" align="center" prop="nickname" min-width="150px" fixed="left" />
      <el-table-column label="姓名" align="center" prop="name" />
      <el-table-column label="状态" align="center" prop="status">
        <template #default="{row}">
          {{ row.status === 1 ? '正常' : '非正常' }}
        </template>
      </el-table-column>
      <el-table-column label="手机号" align="center" prop="mobile"  min-width="150px" />
      <el-table-column label="是否VIP" align="center" prop="isVip">
        <template #default="{row}">
          {{ row.isVip === 1 ? '是' : '否' }}
        </template>
      </el-table-column>
      <el-table-column label="头像" align="center" prop="avatar">
        <template #default="{row}">
	        <viewer :images="[row.avatar]">
		        <img v-if="row.avatar" :src="row.avatar" style="width: 60px; height: 60px; object-fit: cover;" />
            <img v-else src="http://43.138.81.125:8009/i/user/default-avatar.png" style="width: 60px; height: 60px; object-fit: cover;" />
	        </viewer>
        </template>
      </el-table-column>
      <el-table-column
        label="vip过期时间"
        align="center"
        prop="vipExpireDate"
        :formatter="dateFormatter"
        width="180px"
      />
      
      <el-table-column label="是否拉黑" align="center" prop="isBanned">
        <template #default="{row}">
          {{ row.isBanned === 1 ? '是' : '否' }}
        </template>
      </el-table-column>
      <el-table-column
        label="拉黑时间"
        align="center"
        prop="banTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column
        label="解封时间"
        align="center"
        prop="releaseTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" fixed="right" min-width="500px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
          >
            删除
          </el-button>

          <el-popconfirm v-if="scope.row.isBanned === 0" :title="scope.row.isVip === 1 ? '确定设为普通用户?' : '确定设为VIP用户?'" width="250px" @confirm="onSetVip(scope.row.id)">
            <template #reference>
              <el-button link type="danger">{{ scope.row.isVip === 1 ? '设置为普通用户' : '设置为VIP用户' }}</el-button>
            </template>
          </el-popconfirm>

          <el-popconfirm v-if="scope.row.isBanned === 0" title="是否拉黑此用户?" width="250px" @confirm="onSetBanned(scope.row.id)">
            <template #reference>
              <el-button link type="danger">设置拉黑</el-button>
            </template>
          </el-popconfirm>
          <br>
          <el-popconfirm v-if="scope.row.isBanned === 1" title="是否改变此用户状态为正常?" width="250px" @confirm="onSetBanned(scope.row.id)">
            <template #reference>
              <el-button link type="danger">取消拉黑</el-button>
            </template>
          </el-popconfirm>
          <el-button link type="info" @click="router.push({ path: '/request/request', query: { userId: scope.row.id } })">查看需求单</el-button>
          <el-button link type="info" @click="router.push({ path: '/order/order', query: { userId: scope.row.id } })">查看订单</el-button>
          <el-button link type="info" @click="router.push({ path: '/yuesao/suggestion', query: { userId: scope.row.id } })">查看意见反馈</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <YSUserForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as YSUserApi from '@/api/ySUser'
import YSUserForm from './YSUserForm.vue'

defineOptions({ name: 'YSUser' })

const router = useRouter()
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  id: undefined,
  nickname: null,
  password: null,
  status: null,
  registerIp: null,
  loginIp: null,
  loginDate: [],
  avatar: null,
  name: null,
  sex: null,
  mobile: null,
  cityId: null,
  cityName: null,
  isVip: null,
  vipExpireDate: [],
  isBanned: null,
  point: null,
  banTime: [],
  releaseTime: [],
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await YSUserApi.getYSUserPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await YSUserApi.deleteYSUser(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await YSUserApi.exportYSUser(queryParams)
    download.excel(data, '月嫂程序用户.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

const onSetBanned = async (id: number) => {
  await YSUserApi.setBannedYSUser(id);
  handleQuery();
}

const onSetVip = async (id: number) => {
  await YSUserApi.setVipYSUser(id);
  handleQuery();
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
